mb/ocp/deltalake: Configure FSP DCI via VPD
[coreboot.git] / util / release / genrelnotes
blob5bd1a965e5daabd430e8764855c9e46d2f1b97d3
1 #!/usr/bin/env bash
3 # SPDX-License-Identifier: GPL-2.0-only
5 # This script creates a list of commits between two releases, broken out into
6 # fairly inexact categories, based on the directories that files are in. If
7 # a commit touched anything in the path that is checked earlier, it's counted
8 # as being in that category.
10 # Don't run this in your current working tree, it checks out different versions
11 # and can lose things.
13 # set -x # uncomment for debug
15 # Check for tools
17 if ! ( git --version && cloc --version && rename --version ) > /dev/null 2>&1
18 then
19 echo "ERROR: cloc, git or rename is not installed. Exiting"
20 exit 1
23 if ! { cdup="$(git rev-parse --show-cdup 2>/dev/null)" && [ -z "${cdup}" ]; }
24 then
25 echo "ERROR: This is not the top directory of a git repo. Exiting."
26 exit 1
29 # Try to verify that the repo is clean before losing state.
30 if ! git diff-index --quiet --cached HEAD 2>/dev/null; then
31 echo "ERROR: repo is not clean. Exiting."
32 exit 1
35 # Verify the command line arguments
36 if [ "$1" == "--help" ] || [ -z "$1" ] || [ -z "$2" ]; then
37 echo
38 echo "Usage: $0 <old_version> <new_version> [release notes file]"
39 echo "Old version should be a tag (4.1), a branch (origin/4.1), or a commit id"
40 echo "New version can be 'HEAD' a branch (origin/master) a tag (4.2), or a commit id"
41 echo "Logfile can be a new file or an existing file to update"
42 echo "Example: \"$0 origin/4.1 4.2 rnotes.txt\""
43 echo
44 echo "Note that the script starts at the commit AFTER the old version."
45 echo
46 exit 1
47 else
48 OLD_GIT_VERSION="$1"
49 NEW_GIT_VERSION="$2"
50 if [ "$OLD_GIT_VERSION" = "HEAD" -o "$NEW_GIT_VERSION" = "HEAD" ]; then
51 echo "Error: using HEAD as a reference doesn't work"
52 echo
53 exit 1
55 TOTAL_COMMITS=$(git log --pretty=oneline \
56 "${OLD_GIT_VERSION}..${NEW_GIT_VERSION}" 2>/dev/null | wc -l)
59 TOP=$(pwd)
61 if [ -n "$3" ]; then
62 MAIN_LOGFILE="${TOP}/$3"
63 else
64 MAIN_LOGFILE="${TOP}/relnotes.txt"
67 # Figure out which logfile we're writing to. If the specified logfile exists,
68 # we need to write to a temporary logfile, then append changes to the main
69 # logfile.
70 if [ -f "$MAIN_LOGFILE" ]; then
71 LOGFILE="$(mktemp "LOGFILE.XXXX")"
72 LOGFILE="${TOP}/$LOGFILE"
73 UPDATE_MAIN_LOGFILE=1
74 else
75 LOGFILE="$MAIN_LOGFILE"
78 get_author_commit_count() {
79 git log "${NEW_GIT_VERSION}" 2>/dev/null | grep -c "^Author: $1"
82 # Print and log the versions
83 log_versions() {
84 echo "Log of commit $1 to commit $2"
85 echo "Log of commit $1 to commit $2" >> "$LOGFILE"
86 echo "Total commits: ${TOTAL_COMMITS}"
87 echo "Total commits: ${TOTAL_COMMITS}" >> "$LOGFILE"
88 echo
91 # Get the first commit id in the current tree
92 get_latest_commit_id() {
94 cd "$1"
95 git log 2>/dev/null | grep '^commit ' | head -1 | sed 's/commit //'
99 # Main get log function
100 _get_log() {
101 local oldver="$1"
102 local newver="$2"
103 local title="$3"
104 local paths="$4"
105 local keywords="$5"
107 # Leave ${paths} unquoted in the git commands
108 # shellcheck disable=SC2086
110 if [ -n "$paths" ]; then \
111 git log --abbrev-commit --pretty=oneline \
112 "${oldver}..${newver}" -- ${paths} \
113 2>/dev/null; \
114 fi; \
115 if [ -n "$keywords" ]; then \
116 git log --abbrev-commit --pretty=oneline \
117 "${oldver}..${newver}" 2>/dev/null \
118 | grep -i "$keywords"; \
119 fi \
120 } | sort -t ' ' -k 2 | uniq
123 # Output to a new log, then compare to the first logfile, and only output
124 # non duplicated lines to the final file.
125 get_log_dedupe() {
126 local title="$1"
127 local paths="$2"
128 local keywords="$3"
129 local log
130 local commits
132 dedupe_tmpfile="$(mktemp "LOGFILE.XXXX")"
134 log=$(_get_log "$OLD_GIT_VERSION" "$NEW_GIT_VERSION" \
135 "$title" "$paths" "$keywords")
137 echo "$log" > "$dedupe_tmpfile"
139 log=$(grep -Fxv -f "$LOGFILE" "$dedupe_tmpfile")
140 commits=$(echo "$log" | wc -l)
142 #echo "$title: $paths $keywords" >> "$LOGFILE"
143 printf "%s\n%s\n\n" "##### $title ($commits commits) #####" \
144 "$log" >> "$LOGFILE"
146 rm "$dedupe_tmpfile"
149 # get logs for the submodules
150 get_log_submodule() {
151 local old_version="$1"
152 local new_version="$2"
153 local submodule_dir="$3"
154 local log
155 local commits
157 printf "Submodule %s\n" "$submodule_dir"
158 printf "commit %s to commit %s\n\n" "$old_version" "$new_version"
161 cd "${TOP}/$submodule_dir"
162 log="$(_get_log "$old_version" "$new_version" "$submodule_dir" "." "")"
163 commits=$(echo "$log" | wc -l)
165 if [ -n "$log" ]; then
166 printf "%s\n" "$submodule_dir ($commits commits)" >> "$LOGFILE"
167 printf "\n" >> "$LOGFILE"
172 find_areas() {
173 local directory="$1"
174 local filename="$2"
175 local skip="$3"
176 find "$directory" -name "$filename" | sed "s|/$filename||" | sed "s|/$directory||" | grep -v "$skip" | sort
179 # Make sure things get cleaned up if ctl-c is pressed while the old version
180 # is checked out and files are renamed. This can be a real mess to clean
181 # up manually.
182 version_ctrl_c() {
183 printf "\n** Trapped CTRL-C\n Cleaning up and exiting.\n"
184 find 'src' -name 'gnumakefile' \
185 -exec rename 's/gnumakefile/Makefile\.inc/' {} \;
186 git checkout origin/master > /dev/null 2>&1
187 git submodule update --init --checkout > /dev/null 2>&1
188 rm "$LOGFILE"
189 exit 1;
192 # Calculate areas that have been added or removed based on file lists
193 show_diff () {
194 local new
195 local old
197 new="$(comm -13 <(echo "$2") <(echo "$3"))"
198 old="$(comm -23 <(echo "$2") <(echo "$3"))"
200 # Allow running a postprocessor, given as 4th argument over the
201 # resulting diff, provide context if it's old or new data
202 if [ -n "$4" ]; then
203 new=$(echo "$new" | $4 new | sort)
204 old=$(echo "$old" | $4 old | sort)
206 new="$(printf "$new" | sed 's/^/* /')"
207 old="$(printf "$old" | sed 's/^/* /')"
209 if [ -n "$new" ]; then
210 printf "Added %s $1:\n-------------------\n%s\n\n" \
211 "$(echo "$new" | wc -l)" "$new" >> "$LOGFILE"
213 if [ -n "$old" ]; then
214 printf "Removed %s $1:\n-------------------\n%s\n\n" \
215 "$(echo "$old" | wc -l)" "$old" >> "$LOGFILE"
219 get_sloc () {
220 # Because cloc works on extensions, and .inc identifies as pascal,
221 # while we use it both for Makefile.inc and some files that are
222 # really C, do three passes: everything but .inc files, all .inc files
223 # that aren't Makefiles, all Makefile.inc, then combine them.
225 local base=`mktemp`
226 find src -name Makefile.inc > ${base}.mak
228 cloc --progress-rate=0 --quiet \
229 --script-lang="Bourne Shell",bash --exclude-ext=inc \
230 --exclude-dir=vendorcode --out=${base} src
231 cloc --progress-rate=0 --quiet \
232 --exclude-list-file=${base}.mak --force-lang=c,inc \
233 --exclude-dir=vendorcode --out=${base}.c src
234 cloc --progress-rate=0 --quiet \
235 --list-file=${base}.mak --force-lang=make,inc \
236 --exclude-dir=vendorcode --out=${base}.m src
237 cloc --progress-rate=0 --quiet --sum-reports \
238 ${base} ${base}.c ${base}.m --out ${base}.result
240 echo
241 cat ${base}.result.lang
243 rm -f ${base}*
246 # Start collecting data from the old and new revisions.
247 # This is relatively disruptive to the tree, so trap on ctl-c so that
248 # things can be put back to normal
249 trap version_ctrl_c SIGINT
251 #check out old version and get information
252 printf -- "Finding old submodule versions...\n"
253 git checkout "$OLD_GIT_VERSION" > /dev/null 2>&1
254 git submodule update --init --checkout > /dev/null 2>&1
255 for module in $(git submodule --quiet foreach pwd); do
256 name="$(basename "$module" | sed 's/-/_/g')"
257 version="${name^^}_OLD_VERSION"
258 declare "$version"=$(get_latest_commit_id "$module")
259 done
261 printf "Logging directories in the old tree\n"
262 mainboard_list_old=$(grep -h "^[[:space:]]*config\>[[:space:]]*\<BOARD_" src/mainboard/*/*/Kconfig.name 2>/dev/null | sed "s,^.*\<BOARD_\([A-Z0-9_]*\)\>.*$,\1," | sort)
263 cpu_list_old=$(find_areas "src/cpu" "Kconfig" "intel/common")
264 soc_list_old=$(find_areas "src/soc" "Makefile.inc" "intel/common\|amd/common\|romstage")
265 northbridge_list_old=$(find_areas "src/northbridge" "Kconfig" "")
266 sio_list_old=$(find_areas "src/superio" "Makefile.inc" "")
267 southbridge_list_old=$(find_areas "src/southbridge" "Kconfig" "")
269 printf "Calculating old SLOC\n"
270 OLD_SLOC=$(get_sloc)
272 #check out new version and get information
273 printf -- "\nFinding new submodule versions...\n"
274 git checkout "$NEW_GIT_VERSION" > /dev/null 2>&1
275 git submodule update --init --checkout > /dev/null 2>&1
277 for module in $(git submodule --quiet foreach pwd); do
278 name="$(basename "$module" | sed 's/-/_/g')"
279 version="${name^^}_NEW_VERSION"
280 declare "$version"=$(get_latest_commit_id "$module")
281 done
283 printf "Logging directories in the new tree\n"
284 mainboard_list_new=$(grep -h "^[[:space:]]*config\>[[:space:]]*\<BOARD_" src/mainboard/*/*/Kconfig.name 2>/dev/null | sed "s,^.*\<BOARD_\([A-Z0-9_]*\)\>.*$,\1," | sort)
285 cpu_list_new=$(find_areas "src/cpu" "Kconfig" "intel/common")
286 soc_list_new=$(find_areas "src/soc" "Makefile.inc" "intel/common\|amd/common\|romstage")
287 northbridge_list_new=$(find_areas "src/northbridge" "Kconfig" "")
288 sio_list_new=$(find_areas "src/superio" "Makefile.inc" "")
289 southbridge_list_new=$(find_areas "src/southbridge" "Kconfig" "")
291 printf "Calculating new SLOC\n"
292 NEW_SLOC=$(get_sloc)
294 git checkout origin/master > /dev/null 2>&1
295 git submodule update --init --checkout > /dev/null 2>&1
296 trap "" SIGINT
297 # Done collecting data from the old and new versions
299 # Start outputting to logfile
300 echo "Generating release notes from version ${OLD_GIT_VERSION} to ${NEW_GIT_VERSION}"
301 echo; echo "Main repo"
302 echo "Main repo" >> "$LOGFILE"
303 echo "------------------" >> "$LOGFILE"
304 log_versions "$(git log --pretty=%H \
305 "${OLD_GIT_VERSION}..${NEW_GIT_VERSION}" 2>/dev/null | tail -1)" \
306 "$(git log --pretty=%H \
307 "${OLD_GIT_VERSION}..${NEW_GIT_VERSION}" 2>/dev/null | head -1 )"
308 echo "" >> "$LOGFILE"
310 ### SPECIFIC AREAS FOR RELEASE ###
311 get_log_dedupe "cleanup" "" "spelling\|Use tabs\|transition away from device_t\|space [around\|before]\|code formatting\|commented code\|code cleanup\|capitalize\|unnecessary whitespace\|checkpatch\|remove unused\|remove.*not used"
313 get_log_dedupe "Google Kahlee / AMD Gardenia" "src/mainboard/google/kahlee src/mainboard/amd/gardenia" "kahlee\|gardenia"
314 get_log_dedupe "AMD Stoney Ridge" "src/soc/amd/stoneyridge" "stoney"
316 get_log_dedupe "Google Eve / Poppy / Fizz / Soraka / Nautilus / Intel KblRvp" "src/mainboard/google/eve src/mainboard/google/poppy src/mainboard/google/fizz src/mainboard/intel/kblrvp" "eve[ :]\|poppy\|fizz\|soraka\|nautilus\|kblrvp"
317 #get_log_dedupe "Intel Kunimitsu / Google Chell / Lars / Glados" "src/mainboard/google/lars src/mainboard/google/chell src/mainboard/google/glados src/mainboard/intel/kunimitsu" "chell\|lars\|kunimitsu"
318 get_log_dedupe "Purism SKL" "src/mainboard/purism/librem_skl" "librem13v2\|librem_skl"
319 get_log_dedupe "Intel Skylake / Kabylake" "src/soc/intel/skylake" "skylake\|sky.lake\|kabylake\|kaby.lake"
321 get_log_dedupe "Google Cyan / Intel Strago" "src/mainboard/google/cyan src/mainboard/intel/strago" "cyan\|strago"
322 get_log_dedupe "Intel Braswell" "src/soc/intel/braswell" "braswell"
324 get_log_dedupe "Google Kevin / Gru / Bob / Scarlet / Nefario" "src/mainboard/google/gru" "kevin\|gru[^b]"
325 get_log_dedupe "Rockchip rk3399" "src/soc/rockchip/rk3399" "rk3399"
327 get_log_dedupe "Google Reef / Pyro / Sand / Snappy / Nasher" "src/mainboard/google/reef" "reef\|pyro\|sand[ :]\|snappy\|nasher"
328 #get_log_dedupe "Intel apollolake_rvp leafhill minnow3" "src/mainboard/intel/apollolake_rvp src/mainboard/intel/leafhill src/mainboard/intel/minnow3" "apollolake_rvp\|leafhill\|minnow3"
329 get_log_dedupe "Siemens mc_apl1" "src/mainboard/siemens/mc_apl1" "mc_apl1"
330 get_log_dedupe "Intel Apollolake" "src/soc/intel/apollolake" "apollolake\|apollo.lake"
332 get_log_dedupe "Intel CannonLake" "src/soc/intel/cannonlake src/mainboard/intel/cannonlake_rvp" "cannonlake"
334 get_log_dedupe "Intel Galileo" "src/mainboard/intel/galileo" "galileo"
335 get_log_dedupe "Intel Quark" "src/soc/intel/quark" "quark"
337 get_log_dedupe "Intel Baytrail" "src/soc/intel/baytrail" "baytrail"
338 #get_log_dedupe "Google Gale / Qualcomm QX ipq40xx" "src/mainboard/google/gale src/soc/qualcomm/ipq40xx" "gale\|ipq40"
339 #et_log_dedupe "Google Rotor / Marvell Mvmap2315" "src/soc/marvell/mvmap2315 src/mainboard/google/rotor" "marvell\|mvmap\|rotor"
341 get_log_dedupe "Gigabyte ga-g41m-es2l" "src/mainboard/gigabyte/ga-g41m-es2l" "es2l"
342 get_log_dedupe "Intel x4x northbridge / LGA775" "src/northbridge/intel/x4x src/cpu/intel/socket_LGA775" "x4x\|lga775"
344 get_log_dedupe "Intel Sandybridge / Ivybridge" "src/southbridge/intel/bd82x6x src/southbridge/intel/fsp_bd82x6x src/northbridge/intel/sandybridge src/northbridge/intel/fsp_sandybridge src/cpu/intel/fsp_model_206ax src/cpu/intel/model_206ax" "sandybridge\|ivybridge\|bd82x6x"
346 get_log_dedupe "Intel Common" "src/soc/intel/common src/southbridge/intel/common src/northbridge/intel/common" ""
347 get_log_dedupe "Amd Common" "src/soc/amd/common src/southbridge/amd/common" ""
349 get_log_dedupe "Nvidia" "src/southbridge/nvidia" ""
350 get_log_dedupe "Via" "src/northbridge/via src/southbridge/via" ""
351 get_log_dedupe "Broadcom" "src/southbridge/broadcom" ""
352 get_log_dedupe "Qualcomm" "src/soc/qualcomm" ""
354 get_log_dedupe "Intel vendorcode / FSP" "src/drivers/intel/fsp* src/vendorcode/intel" ""
355 get_log_dedupe "AMD vendorcode / AGESA / PI" "src/vendorcode/amd" ""
356 get_log_dedupe "Google vendorcode" "src/vendorcode/google"
358 get_log_dedupe "TPM" "src/drivers/i2c/tpm src/security/tpm" "tpm"
359 get_log_dedupe "Vboot" "src/vboot" "vboot"
362 ### GENERAL AREAS FOR RELEASE ###
363 # shellcheck disable=SC2013
365 get_log_dedupe "ARM" \
366 "$(for codedir in $(grep -rl "_ARM" --include=Kconfig | \
367 grep -v 'src/mainboard\|payloads/\|drivers/\|vendorcode/\|console' ); \
368 do dirname "$codedir"; done | grep -v '^src$')"
370 get_log_dedupe "RISC-V" \
371 "$(for codedir in $(grep -rl "_RISCV" --include=Kconfig | grep -v 'payloads/\|drivers/\|vendorcode/\|console' ); do dirname "$codedir"; done | grep -v '^src$')" \
372 "riscv\|risc-v\|sifive"
375 get_log_dedupe "X86 intel" \
376 "src/cpu/intel src/soc/intel src/northbridge/intel \
377 src/southbridge/intel src/include/intel src/drivers/intel"
379 get_log_dedupe "X86 amd" \
380 "src/cpu/amd src/northbridge/amd src/southbridge/amd src/include/amd src/soc/amd" \
381 "agesa\|binarypi\|binary.pi"
383 get_log_dedupe "X86 common" \
384 "src/arch/x86 src/cpu/x86 src/include/x86 src/include/pc80"
386 get_log_dedupe "Mainboards" "src/mainboard/"
388 # Next, print all the rest of the specific areas
389 get_log_dedupe "ACPI" "src/acpi/"
390 get_log_dedupe "Console" "src/console src/include/console"
391 get_log_dedupe "SuperIO" "src/superio src/include/superio"
392 get_log_dedupe "EC" "src/ec"
393 get_log_dedupe "Drivers" "src/drivers"
394 get_log_dedupe "Devices" "src/device src/include/device"
396 # 5th, print the generic areas - This goes late so that the specific
397 # area changes will catch any commits in these areas first.
398 get_log_dedupe "Toolchain" "util/crossgcc"
399 get_log_dedupe "cbfstool" "util/cbfstool"
400 get_log_dedupe "Lint tools" "util/lint"
401 get_log_dedupe "Lib" "src/lib"
402 get_log_dedupe "Commonlib" "src/commonlib"
403 get_log_dedupe "Include" "src/include"
404 get_log_dedupe "Utilities" "util"
405 get_log_dedupe "Payloads" "payloads"
406 get_log_dedupe "Vendorcode" "src/vendorcode"
407 get_log_dedupe "Documentation" "Documentation README"
409 # Then look at areas that are usually outside the mainboards and architectures
410 get_log_dedupe "Build system" \
411 "Makefile Makefile.inc toolchain.inc src/Kconfig src/cpu/Makefile.inc"
413 get_log_dedupe "Submodules" "3rdparty util/nvidia/cbootimage"
415 get_log_dedupe "Maintainers" "MAINTAINERS" ""
417 # Finally, get anything that was missed above
418 get_log_dedupe "MISC" "."
420 # Replace VENDOR_DEVICE from stdin with their nice names on stdout
421 real_mainboard_names() {
422 local tree_version=$1 # "old" or "new"
423 local git_version_var=${tree_version^^}_GIT_VERSION
424 local git_version=${!git_version_var}
425 local line
427 while read line; do
428 local file="$(git grep -l "^[[:space:]]*config\>[[:space:]]*\<BOARD_${line}\$" ${git_version} -- src/mainboard/\*/\*/Kconfig.name | sed "s,^${git_version}:,,")"
429 if [ -z "$file" ]; then
430 echo "This shouldn't happen: couldn't find Kconfig for $line"
431 exit 1
433 local vendor="$(git grep \" ${git_version} -- $(echo ${file} | cut -d/ -f1-3,5) | cut -d\" -f2)"
434 git grep -h -A1 "^[[:space:]]*config\>[[:space:]]*\<BOARD_${line}\$" ${git_version} -- ${file} | grep \" |cut -d\" -f2 |sed "s,^,${vendor} ,"
435 done
438 # Show areas that have been added or removed
439 show_diff "mainboards" "$mainboard_list_old" "$mainboard_list_new" real_mainboard_names
440 show_diff "processors" "$cpu_list_old" "$cpu_list_new"
441 show_diff "socs" "$soc_list_old" "$soc_list_new"
442 show_diff "northbridges" "$northbridge_list_old" "$northbridge_list_new"
443 show_diff "southbridges" "$southbridge_list_old" "$southbridge_list_new"
444 show_diff "sios" "$sio_list_old" "$sio_list_new"
446 # Log submodules
447 printf "Submodules\n----------\n" >> "$LOGFILE"
448 for module in $(git submodule --quiet foreach pwd); do
449 name=$(basename "$module")
450 # shellcheck disable=SC2001
451 path=${module#$PWD}
452 old_version=$(echo "${name^^}_OLD_VERSION" | sed 's/-/_/g')
453 new_version=$(echo "${name^^}_NEW_VERSION" | sed 's/-/_/g')
454 get_log_submodule "${!old_version}" "${!new_version}" "$path"
455 done
457 printf "\nrepo statistics\n-------------------\n" >> "$LOGFILE"
458 before_names="$(mktemp "OLDNAMES.XXXX")"
459 after_names="$(mktemp "NEWNAMES.XXXX")"
460 NEW_AUTHORS=$(git log --pretty=%an "${OLD_GIT_VERSION}" 2>/dev/null | sort | \
461 uniq > "$before_names" && \
462 git log --pretty=%an "${NEW_GIT_VERSION}" 2>/dev/null | \
463 sort | uniq > "$after_names" && \
464 grep -Fxv -c -f "$before_names" "$after_names")
465 NEW_AUTHOR_LIST=$( grep -Fxv -f "$before_names" "$after_names")
466 rm -f "$before_names" "$after_names"
468 printf -- "- Total commits: %s\n" "$TOTAL_COMMITS"
469 printf -- "- Total authors: %s\n" \
470 "$(git log "${OLD_GIT_VERSION}..${NEW_GIT_VERSION}" 2>/dev/null | \
471 grep -e '^Author:' | sed 's/.*Author: //' | sed 's/ <.*.>//' | \
472 sort | uniq | wc -l)"
473 printf -- "- New authors: %s\n\nNew Authors:\n%s\n" "$NEW_AUTHORS" \
474 "$NEW_AUTHOR_LIST"
475 } >> "$LOGFILE"
477 printf "Getting developer list\n"
478 printf "\n%-40s: %5s\n" "Developer" "Commits" >> "$LOGFILE"
479 git log "${OLD_GIT_VERSION}..${NEW_GIT_VERSION}" 2>/dev/null | grep '^Author: ' | \
480 sed 's|Author: ||' | sed 's|\s<.*||' | sort | uniq | \
481 while read -r line; do
482 printf "%-40s: %5s %5s\n" "$line" \
483 "$(git log "${OLD_GIT_VERSION}" 2>/dev/null | \
484 grep -c "^Author: ${line} <")" \
485 "$(git log "${NEW_GIT_VERSION}" 2>/dev/null | \
486 grep -c "^Author: ${line} <")" >> "$LOGFILE";
487 done
489 printf "\nOld SLOC (%s)\n%s" "$NOW" "$OLD_SLOC" >> "$LOGFILE"
490 printf "\nNew SLOC (%s)\n%s" "$NOW" "$NEW_SLOC" >> "$LOGFILE"
492 # Add the collected data to the top of the existing logfile for parsing
493 if [ -n "$UPDATE_MAIN_LOGFILE" ]; then
494 tmpfile="$(mktemp "LOGFILE.XXXX")"
495 grep -Fxv -f "$MAIN_LOGFILE" "$LOGFILE" > "$tmpfile"
496 printf "\n\n" >> "$tmpfile"
497 cat "$MAIN_LOGFILE" >> "$tmpfile"
498 mv "$tmpfile" "$MAIN_LOGFILE"
499 rm -f "$LOGFILE"
502 printf "Done.\n"